#!/usr/bin/env python

#!/usr/bin/env python

import unittest

simplexml = """<?xml version='1.0' encoding='utf-8' ?>
<host xmlns='http://psha.org.ru/ns/mnet' uuid='test'>
	<detail attr='val'>yohoho</detail>
        <ns1:tag xmlns:ns1="urn:test"/>
	<!--<tag/>-->
</host>
"""

class lx2pxTestCase(unittest.TestCase):
	"Test case for hostinfo parsers"
	def check_l2p(self):
                import libxml2
                import xml.dom
                from zsixmpp.libxml2pyxml import libxml2pyxml, pyxml2libxml
                doc0 = libxml2.parseDoc(simplexml)
                doc1 = libxml2.newDoc("1.0")
                pydoc = xml.dom.getDOMImplementation().createDocument(None, None, None)

                pyelt = libxml2pyxml(doc0.children, pydoc)

                e = pyxml2libxml(pyelt, doc1)

                c14_0 = doc0.c14nMemory()
                c14_1 = doc1.c14nMemory()
                """
                print "================="
                print c14_0
                print "-----------------"
                print pyelt.toxml()
                print "-----------------"
                print c14_1
                print "================="
                """
		assert c14_0 == c14_1, "libxml2 to pyxml to libxml2 conversion failed"
	def check_p2l(self):
                from xml.dom import minidom
                import xml.dom
                from ZSI.wstools.c14n import Canonicalize
                import libxml2

                from zsixmpp.libxml2pyxml import libxml2pyxml, pyxml2libxml
		doc0 = minidom.parseString(simplexml)
                doc1 = xml.dom.getDOMImplementation().createDocument(None, None, None)
                l2doc = libxml2.newDoc("1.0")

                l2e = pyxml2libxml(doc0.childNodes[0], l2doc)

                e = libxml2pyxml(l2e, doc1)
                c14_0 = Canonicalize(doc0.childNodes[0])
                c14_1 = Canonicalize(e)
                """
                print "================="
                print c14_0
                print "-----------------"
                print l2e
                print "-----------------"
                print c14_1
                print "================="
                """
		assert c14_0 == c14_1, "pyxml to libxml2 to pyxmlconversion failed"



def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(lx2pxTestCase, "check"))
    return suite

defaultTest = makeTestSuite

def main():
    unittest.main(defaultTest="defaultTest")


if __name__ == "__main__" : main()


